#include <cctype>
#include <dirent.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>

#include "directory.h"

directory::~directory (void)
{
}

void
directory::scan (const std::string &dir)
{
    DIR *ttfdir = opendir(dir.c_str ());

    this->clear ();
    dirpath = dir;
    dirpath += '/';
    
    while (struct dirent *entry = readdir (ttfdir)) {
	std::string name = path () + entry->d_name;
	if (this->select (name.c_str ())) {
	    this->push_back (entry->d_name);
	}
    }

    closedir (ttfdir);
}

bool
directory::select (const char *name) const
{
    return true;
}

bool
ttfdirectory::select (const char *name) const
{
    int fd;
    unsigned int n;
    struct stat buf;
    char sigdata[8];
    char TTsig[] = "\000\001\000\000\000", OTsig[] = "OTTO";

    /* must be a regular file */
    if (::stat (name, &buf) || !(S_ISREG (buf.st_mode))) {
	return false;
    }

    fd = ::open(name, O_RDONLY);
    if (fd < 0) return false;
    n = read(fd, sigdata, sizeof(sigdata));
    close(fd);
    if (n < sizeof(sigdata))
	return false;

    return (!memcmp(sigdata, TTsig, 5)
	    || !memcmp(sigdata, OTsig, 4));
}
